;=======================================================
; misc routines
;=======================================================

;=======================================================
; spriteDrawBigMirrored
;=======================================================
; draws a 16x16 mirrored grayscale sprite


;=======================================================
; spriteDrawMirrored
;=======================================================
; draws a mirrored grayscale sprite
; a=x l=y ix=sprite adress
spriteDrawMirrored:
	push af
	push hl
	ld hl,sdm_temp
	ld b,16
sdm_loop:
	push bc
	push hl
	ld a,(ix)
	call byteGetMirror
	pop hl
	ld (hl),a
	inc hl
	inc ix
	pop bc
	djnz sdm_loop
	pop hl
	pop af
	ld ix,sdm_temp
	call gsAlignedMaskedSprite
	ret
sdm_temp:
	.db 0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0


;================================================
; byteGetMirror
;================================================
byteGetMirror:
	ld e,a
	and %00001111
	ld b,0 \ ld c,a
	ld hl,LUT1
	add hl,bc
	ld a,(hl) ;first nibble ready
	ld d,a
	ld a,e
	rra
	rra
	rra
	rra
	and %00001111
	ld c,a
	ld hl,LUT2
	add hl,bc
	ld a,(hl) ;second nibble ready
	or d      ;combine nibbles
	ret
				
LUT1:
	.db %00000000, %10000000, %01000000, %11000000 ;1st nibble
	.db %00100000, %10100000, %01100000, %11100000
	.db %00010000, %10010000, %01010000, %11010000
	.db %00110000, %10110000, %01110000, %11110000
LUT2:
	.db %00000000, %00001000, %00000100, %00001100 ;2nd nibble
	.db %00000010, %00001010, %00000110, %00001110
	.db %00000001, %00001001, %00000101, %00001101
	.db %00000011, %00001011, %00000111, %00001111
